#ifndef ___PRIMO_PLATFORM_REFERENCE_H___
#define ___PRIMO_PLATFORM_REFERENCE_H___

/** @file */

#include "PrimoConfig.h"
#include <memory>

/**	
	Top namespace for all libraries developed by Primo Software Corp 
*/
namespace primo
{
/**
	Base class for all objects that require reference management
*/
class Reference
{
public:
	/**
		Retains the instance. Increments the internal reference count.

		@return the updated reference count.
	*/
	virtual int32_t retain() const = 0;

	/**
		Releases the instance. Decrements the internal reference count.

		@return the new reference count.
	*/
	virtual int32_t release() const = 0;

	/**
		Returns the current reference count.

		@return the current reference count.
	*/
	virtual int32_t retainCount() const = 0;
};

}

#endif
